﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class controls : MonoBehaviour {

	public GameObject ground;

	private Rigidbody rb;
	private bool isOnGround;
	private bool isJumping;
	private float jumpMultiplier;

	public float jumpFactor;
	public float moveFactor;
	public float overlaySphereRadius;

	public Vector3 vMovement;
	public Vector3 hMovement;

	private bool isFacingRight = true;
	private SpriteRenderer spriteModel;

	private float MAX_NEG_VERT_VELOCITY = -14.00f;


	void Start() {
		isOnGround = false;
		jumpMultiplier = 1f;
		rb = GetComponent<Rigidbody>();

		SpriteRenderer[] listSprites = gameObject.GetComponentsInChildren<SpriteRenderer> ();
		foreach( SpriteRenderer thisSprite in listSprites)
		{
			if (thisSprite.gameObject.name == "Model"){
				spriteModel = thisSprite;
			}
		}
	}

	void Update() {
		//Debug.Log ("isOnGround = " + isOnGround);
		Collider[] hitColliders = Physics.OverlapSphere(gameObject.transform.position, overlaySphereRadius);

		this.hMovement = new Vector3(0.0f, 0.0f, 0.0f);
		this.vMovement = new Vector3(0.0f, 0.0f, 0.0f);

		jumpMultiplier = 1f;
		foreach(Collider coll in hitColliders)
		{
			//Debug.Log (coll.name);
			if (coll.gameObject.tag == "Floor"){
				isOnGround = true;
			}
		}


		if (Input.GetButtonDown("Jump")) {
			if (isOnGround) {
				rb.velocity = new Vector3 (rb.velocity.x, jumpFactor*jumpMultiplier, 0.0f);
				isOnGround = false;
			}
		}

		if (rb.velocity.y <=0.0f && isOnGround == false){
			Vector3 currentVelocity = rb.velocity;
			rb.velocity = new Vector3 (
				currentVelocity.x, 
				Mathf.Clamp (currentVelocity.y - jumpFactor, MAX_NEG_VERT_VELOCITY, 0.0f),
				currentVelocity.z
			);
		}
			

		if (Input.GetAxis("Horizontal") > 0 ) {
			if (!isFacingRight) {
				isFacingRight = true;
				spriteModel.flipX = false;
			}
			rb.velocity = new Vector3 (moveFactor, rb.velocity.y, 0.0f);
		} else if (Input.GetAxis("Horizontal") < 0 ) {
			if (isFacingRight){
				isFacingRight = false;
				spriteModel.flipX = true;
			}
			rb.velocity = new Vector3 (moveFactor*(-1.0f), rb.velocity.y, 0.0f);
		} else {
			rb.velocity = new Vector3 (0.0f, 0.0f, 0.0f);
		}

	}
}
